[CCode (cheader_filename = "guniqueapp.h")]
namespace GLib.Unique {
	[CCode (cname="GUniqueAppCommand", cprefix = "G_UNIQUE_APP_", has_type_id = "0", cheader_filename = "guniqueapp-base.h")]
	public enum Command {
		ACTIVATE,
		NEW,
		OPEN,
		CUSTOM
	}

	[CCode (cheader_filename = "guniqueapp-base.h")]
	public class App : GLib.Object {
    [NoAccessorMethod]
	  public string name { owned get; construct; }
    [NoAccessorMethod]
	  public string startup_id { owned get; construct; }
    [NoAccessorMethod]
	  public uint workspace { get; construct; }
		[CCode (has_construct_function = false, cname="g_unique_app_get", cheader_filename = "guniqueapp.h")]
    public App (string name);
		[CCode (has_construct_function = false, cname="g_unique_app_get_with_startup_id", cheader_filename = "guniqueapp.h")]
    public App.with_startup_id (string name, string startup_id);
		public void activate ();
		public void new_document ();
		public void open_uri (string uri);
		public void custom_message (string data);
		public virtual bool is_running ();
		public virtual void send_message (Command command, string data);
    public signal void message (Command command, string data, string startup_id, uint workspace);
	}

	[CCode (cheader_filename = "guniqueapp-bacon.h")]
	public class AppBacon : App {
    public AppBacon (string name);
    public AppBacon.with_startup_id (string name, string startup_id);
	}

	[CCode (cheader_filename = "guniqueapp-dbus.h")]
	public class DbusApp : App {
    public DbusApp (string name);
    public DbusApp.with_startup_id (string name, string startup_id);
	}
}

